;CodeVisionAVR C Compiler V1.24.2c Professional
;(C) Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 16,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "Recep01.vec"
	.INCLUDE "Recep01.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.2c Professional
;       4 Automatic Program Generator
;       5  Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : 
;      10 Version : 
;      11 Date    : 12/11/2010
;      12 Author  : F4CG                            
;      13 Company : F4CG                            
;      14 Comments: 
;      15 
;      16 
;      17 Chip type           : ATmega8535
;      18 Program type        : Application
;      19 Clock frequency     : 16,000000 MHz
;      20 Memory model        : Small
;      21 External SRAM size  : 0
;      22 Data Stack size     : 128
;      23 *****************************************************/
;      24 
;      25 #include <mega8535.h>
;      26 
;      27 // Alphanumeric LCD Module functions
;      28 #asm
;      29    .equ __lcd_port=0x15 ;PORTC
   .equ __lcd_port=0x15 ;PORTC
;      30 #endasm

;      31 #include <lcd.h>
;      32 #include <delay.h>     // pour la fonction delay_ms();
;      33 #include <stdlib.h>
;      34 
;      35 // Standard Input/Output functions
;      36 #include <stdio.h>
;      37 
;      38 #define CTS     PIND.4
;      39 #define BUZZER  PINA.7
;      40 
;      41 // Declare your global variables here
;      42 
;      43 unsigned char trame, Statut, Information;
;      44 unsigned char Temps[20]; 
_Temps:
	.BYTE 0x14
;      45 unsigned char tampon[20], Identifiant[10];
_tampon:
	.BYTE 0x14
_Identifiant:
	.BYTE 0xA
;      46 
;      47 void USART_Transmit( unsigned char data )
;      48 {

	.CSEG
_USART_Transmit:
;      49 	/* Wait for empty transmit buffer */
;      50 	while ( !( UCSRA & (0x20)) ); // Test de UDRE bit 5
_0x3:
	SBIS 0xB,5
	RJMP _0x3
;      51 	/* Put data into buffer, sends the data */
;      52 	UDR = data;
	LD   R30,Y
	OUT  0xC,R30
;      53 }
	ADIW R28,1
	RET
;      54 
;      55 unsigned char USART_Receive( void )
;      56 {
_USART_Receive:
;      57 	/* Wait for data to be received */
;      58 	while ( !(UCSRA & 0x80) ); // Test de RXC bit7
_0x6:
	SBIS 0xB,7
	RJMP _0x6
;      59 
;      60 	/* Get and return received data from buffer */
;      61 	return UDR;
	IN   R30,0xC
	RET
;      62 }
;      63 
;      64 int VerifStatut (void)
;      65 {
_VerifStatut:
;      66 	int Presence;
;      67  	while(CTS==1);     //Attente que l'entre CTS soit active ( 0)
	RCALL __SAVELOCR2
;	Presence -> R16,R17
_0x9:
	SBIC 0x10,4
	RJMP _0x9
;      68         trame='S';        //ou 0x53 : permet de vrifier le statut
	LDI  R30,LOW(83)
	RCALL SUBOPT_0x0
;      69         USART_Transmit(trame);
;      70         Statut = USART_Receive();
	RCALL _USART_Receive
	MOV  R5,R30
;      71     
;      72     	if(Statut==0x96)      //Bit d'identification de la carte
	LDI  R30,LOW(150)
	CP   R30,R5
	BRNE _0xC
;      73         {
;      74             Presence=1;
	__GETWRN 16,17,1
;      75             sprintf(tampon,"Lecture  ");
	RCALL SUBOPT_0x1
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x89
;      76             lcd_gotoxy(0,0);
;      77             lcd_puts(tampon);
;      78         }
;      79         else
_0xC:
;      80         {
;      81             Presence=0;
	__GETWRN 16,17,0
;      82             sprintf(tampon,"Pas Carte");
	RCALL SUBOPT_0x1
	__POINTW1FN _0,10
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
_0x89:
	RCALL _sprintf
	ADIW R28,4
;      83             lcd_gotoxy(0,0);
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x3
;      84             lcd_puts(tampon);
	RCALL _lcd_puts
;      85         }
;      86     return Presence;   
	__GETW1R 16,17
	RCALL __LOADLOCR2P
	RET
;      87 }
;      88 
;      89 void Recoit_UID (void)
;      90 {
;      91     int i, z;
;      92 	
;      93     unsigned char car;
;      94     i=0;
;	i -> R16,R17
;	z -> R18,R19
;	car -> R20
;      95     for(z=0;z<7;z++)
;      96     {
;      97     	Identifiant[z] = 0;
;      98     }
;      99     while(CTS==1);
;     100     trame='U',     //ou 0x55 : permet de lire l'UID
;     101     USART_Transmit(trame);
;     102     Statut = USART_Receive();
;     103     
;     104     if(Statut == 150)
;     105     {
;     106     	while(i<=6)     // 6 pour les MIFARE 1k/4k card types
;     107     	{
;     108         	car = USART_Receive();
;     109         	Identifiant[i]=car;
;     110         	i++;
;     111     	}
;     112     }
;     113 
;     114 }
;     115 
;     116 void Recoit_Info (int Borne)
;     117 {
_Recoit_Info:
;     118     int i;
;     119 	
;     120     unsigned char car;
;     121     i=0;
	RCALL __SAVELOCR3
;	Borne -> Y+3
;	i -> R16,R17
;	car -> R18
	__GETWRN 16,17,0
;     122     while(CTS==1);
_0x18:
	SBIC 0x10,4
	RJMP _0x18
;     123     
;     124     trame='R';     //permet de lire la trame
	LDI  R30,LOW(82)
	RCALL SUBOPT_0x0
;     125     USART_Transmit(trame);	//Transmission de 'R' ou 0x52
;     126     USART_Transmit(Borne*18);  	//Transmission de l'adresse de location    
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	LDI  R30,LOW(18)
	LDI  R31,HIGH(18)
	RCALL __MULW12
	ST   -Y,R30
	RCALL _USART_Transmit
;     127     USART_Transmit(0x00);     	//Transmission du code de lecture
	RCALL SUBOPT_0x2
	RCALL _USART_Transmit
;     128     Information = USART_Receive();
	RCALL _USART_Receive
	MOV  R6,R30
;     129     
;     130     Information = (Information & 0xCF);	//Mise en place d'un masque pour lecture ncessaire du Acknowledge 
	MOV  R30,R6
	ANDI R30,LOW(0xCF)
	MOV  R6,R30
;     131     
;     132     
;     133     if(Information == 0x86)
	LDI  R30,LOW(134)
	CP   R30,R6
	BRNE _0x1B
;     134     {
;     135     	//Temps[1] = USART_Receive();
;     136 		
;     137     	while(i<=15)		//16 bits  rcuprer
_0x1C:
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x1E
;     138     	{
;     139     		car = USART_Receive(); 
	RCALL _USART_Receive
	MOV  R18,R30
;     140     		Temps[i] = car;
	__GETW2R 16,17
	SUBI R26,LOW(-_Temps)
	SBCI R27,HIGH(-_Temps)
	ST   X,R18
;     141     		i++;
	__ADDWRN 16,17,1
;     142     	}
	RJMP _0x1C
_0x1E:
;     143     }
;     144 
;     145     	//lcd_clear();
;     146 }  
_0x1B:
	RCALL __LOADLOCR3
	ADIW R28,5
	RET
;     147     
;     148 void main(void)
;     149 {
_main:
;     150 // Declare your local variables here
;     151 
;     152 // Input/Output Ports initialization
;     153 // Port A initialization
;     154 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     155 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     156 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;     157 DDRA=0x00;
	OUT  0x1A,R30
;     158 
;     159 // Port B initialization
;     160 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     161 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     162 PORTB=0x00;
	OUT  0x18,R30
;     163 DDRB=0x00;
	OUT  0x17,R30
;     164 
;     165 // Port C initialization
;     166 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     167 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     168 PORTC=0x00;
	OUT  0x15,R30
;     169 DDRC=0x00;
	OUT  0x14,R30
;     170 
;     171 // Port D initialization
;     172 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     173 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     174 PORTD=0x00;
	OUT  0x12,R30
;     175 DDRD=0x00;
	OUT  0x11,R30
;     176 
;     177 // Timer/Counter 0 initialization
;     178 // Clock source: System Clock
;     179 // Clock value: Timer 0 Stopped
;     180 // Mode: Normal top=FFh
;     181 // OC0 output: Disconnected
;     182 TCCR0=0x00;
	OUT  0x33,R30
;     183 TCNT0=0x00;
	OUT  0x32,R30
;     184 OCR0=0x00;
	OUT  0x3C,R30
;     185 
;     186 // Timer/Counter 1 initialization
;     187 // Clock source: System Clock
;     188 // Clock value: Timer 1 Stopped
;     189 // Mode: Normal top=FFFFh
;     190 // OC1A output: Discon.
;     191 // OC1B output: Discon.
;     192 // Noise Canceler: Off
;     193 // Input Capture on Falling Edge
;     194 TCCR1A=0x00;
	OUT  0x2F,R30
;     195 TCCR1B=0x00;
	OUT  0x2E,R30
;     196 TCNT1H=0x00;
	OUT  0x2D,R30
;     197 TCNT1L=0x00;
	OUT  0x2C,R30
;     198 ICR1H=0x00;
	OUT  0x27,R30
;     199 ICR1L=0x00;
	OUT  0x26,R30
;     200 OCR1AH=0x00;
	OUT  0x2B,R30
;     201 OCR1AL=0x00;
	OUT  0x2A,R30
;     202 OCR1BH=0x00;
	OUT  0x29,R30
;     203 OCR1BL=0x00;
	OUT  0x28,R30
;     204 
;     205 // Timer/Counter 2 initialization
;     206 // Clock source: System Clock
;     207 // Clock value: Timer 2 Stopped
;     208 // Mode: Normal top=FFh
;     209 // OC2 output: Disconnected
;     210 ASSR=0x00;
	OUT  0x22,R30
;     211 TCCR2=0x00;
	OUT  0x25,R30
;     212 TCNT2=0x00;
	OUT  0x24,R30
;     213 OCR2=0x00;
	OUT  0x23,R30
;     214 
;     215 // External Interrupt(s) initialization
;     216 // INT0: Off
;     217 // INT1: Off
;     218 // INT2: Off
;     219 MCUCR=0x00;
	OUT  0x35,R30
;     220 MCUCSR=0x00;
	OUT  0x34,R30
;     221 
;     222 // Timer(s)/Counter(s) Interrupt(s) initialization
;     223 TIMSK=0x00;
	OUT  0x39,R30
;     224 
;     225 // USART initialization
;     226 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     227 // USART Receiver: On
;     228 // USART Transmitter: On
;     229 // USART Mode: Asynchronous
;     230 // USART Baud rate: 9600
;     231 UCSRA=0x00;
	OUT  0xB,R30
;     232 UCSRB=0x18;
	LDI  R30,LOW(24)
	OUT  0xA,R30
;     233 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;     234 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     235 UBRRL=0x67;
	LDI  R30,LOW(103)
	OUT  0x9,R30
;     236 
;     237 // Analog Comparator initialization
;     238 // Analog Comparator: Off
;     239 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     240 // Analog Comparator Output: Off
;     241 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     242 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     243 
;     244 // LCD module initialization
;     245 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
;     246  
;     247 while (1)
_0x1F:
;     248 {
;     249         unsigned char NumeroBorneHexa;
;     250 	int z, PresenceCarte;
;     251 	PresenceCarte = VerifStatut ();   // Appelle de la fonction permettant de vrifier le statut
	SBIW R28,5
;	NumeroBorneHexa -> Y+4
;	z -> Y+2
;	PresenceCarte -> Y+0
	RCALL _VerifStatut
	ST   Y,R30
	STD  Y+1,R31
;     252         
;     253     	NumeroBorneHexa = (PINA&0x0f);
	IN   R30,0x19
	ANDI R30,LOW(0xF)
	STD  Y+4,R30
;     254     
;     255     		sprintf(tampon, "%x", NumeroBorneHexa);
	RCALL SUBOPT_0x1
	__POINTW1FN _0,20
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+8
	RCALL SUBOPT_0x4
	LDI  R24,4
	RCALL SUBOPT_0x5
;     256   		lcd_gotoxy(12, 0);
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x3
;     257   		lcd_puts(tampon);
	RCALL _lcd_puts
;     258     	if(PresenceCarte==1)
	LD   R26,Y
	LDD  R27,Y+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BREQ PC+2
	RJMP _0x22
;     259     	{
;     260     		// Possiblit de lire l'identifiant unique de la carte
;     261 
;     262 		//Recoit_UID();
;     263 		
;     264 		for(z=0;z<4;z++)
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
_0x24:
	RCALL SUBOPT_0x7
	BRGE _0x25
;     265         	{
;     266         		sprintf(tampon,"%3d",Identifiant[z]);
	RCALL SUBOPT_0x1
	__POINTW1FN _0,23
	RCALL SUBOPT_0x8
	SUBI R30,LOW(-_Identifiant)
	SBCI R31,HIGH(-_Identifiant)
	RCALL SUBOPT_0x9
	LDI  R24,4
	RCALL SUBOPT_0x5
;     267     			lcd_gotoxy(z*4,1);   
	RCALL SUBOPT_0xA
;     268     			lcd_puts(tampon);
	RCALL _lcd_puts
;     269         	}
	RCALL SUBOPT_0xB
	RJMP _0x24
_0x25:
;     270         	Recoit_Info(NumeroBorneHexa);
	LDD  R30,Y+4
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Recoit_Info
;     271   		/*sprintf(tampon, "0x%x", Information);	//Affichage du Acknowledge de reception des 16 bits (avec masque)
;     272   		lcd_gotoxy(0,3);
;     273   		lcd_puts(tampon);*/
;     274   		
;     275   		for(z=0;z<4;z++)            	//Lecture complte des 16 bits affich sur 4 lignes
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
_0x27:
	RCALL SUBOPT_0x7
	BRGE _0x28
;     276   		{
;     277   			sprintf(tampon, "%3d", Temps[z]);	//4 premiers bits = UID
	RCALL SUBOPT_0x1
	__POINTW1FN _0,23
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0xC
	LDI  R24,4
	RCALL SUBOPT_0x5
;     278   			lcd_gotoxy(z*4, 1);
	RCALL SUBOPT_0xA
;     279   			lcd_puts(tampon);
	RCALL SUBOPT_0xD
;     280   			
;     281   			sprintf(tampon, "%3d", Temps[z+4]);	//bits qui nous intresse
	__POINTW1FN _0,23
	RCALL SUBOPT_0x8
	ADIW R30,4
	RCALL SUBOPT_0xC
	LDI  R24,4
	RCALL SUBOPT_0x5
;     282   			lcd_gotoxy((z)*4, 2);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x3
;     283   			lcd_puts(tampon);
	RCALL SUBOPT_0xD
;     284   			
;     285   			sprintf(tampon, "%3d", Temps[z+8]);
	__POINTW1FN _0,23
	RCALL SUBOPT_0x8
	ADIW R30,8
	RCALL SUBOPT_0xC
	LDI  R24,4
	RCALL SUBOPT_0x5
;     286   			lcd_gotoxy((z)*4, 3);
	RCALL SUBOPT_0xE
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL SUBOPT_0x3
;     287   			lcd_puts(tampon);
	RCALL _lcd_puts
;     288   			/*
;     289   			sprintf(tampon, "%3d", Temps[z+12]);
;     290   			lcd_gotoxy((z)*4, 3);
;     291   			lcd_puts(tampon);*/
;     292   		}
	RCALL SUBOPT_0xB
	RJMP _0x27
_0x28:
;     293   	
;     294    
;     295 	}  	
;     296         
;     297 }
_0x22:
	ADIW R28,5
	RJMP _0x1F
;     298 }
_0x29:
	RJMP _0x29
;     299 
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G2:
	.BYTE 0x4

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble:
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    andi  r30,0xf0
    ret
_lcd_read_byte0_G2:
    rcall __lcd_delay
    rcall __lcd_read_nibble       ;read MSN
    mov   r26,r30
    rcall __lcd_read_nibble       ;read LSN
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G2)
	SBCI R31,HIGH(-__base_y_G2)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x10
	LDD  R7,Y+1
	LDD  R8,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x11
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x10
	LDI  R30,LOW(0)
	MOV  R8,R30
	MOV  R7,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R7
	CP   R9,R7
	BRSH _0x2B
	__lcd_putchar1:
	INC  R8
	RCALL SUBOPT_0x2
	ST   -Y,R8
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x2B:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
__long_delay_G2:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G2:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R9,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G2,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G2,3
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL __long_delay_G2
	RCALL SUBOPT_0x13
	RCALL __lcd_init_write_G2
	RCALL __long_delay_G2
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x10
	RCALL __long_delay_G2
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x10
	RCALL __long_delay_G2
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x10
	RCALL __long_delay_G2
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G2
	CPI  R30,LOW(0x5)
	BREQ _0x2C
	LDI  R30,LOW(0)
	RJMP _0x88
_0x2C:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x10
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x88:
	ADIW R28,1
	RET
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G4:
	put:
	RCALL SUBOPT_0x14
	SBIW R30,0
	BREQ _0x2D
	RCALL SUBOPT_0x14
	ADIW R30,1
	RCALL __PUTWP1
	SBIW R30,1
	MOVW R26,R30
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0x2E
_0x2D:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _putchar
_0x2E:
	ADIW R28,3
	RET
__print_G4:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0x2F:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x31
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x35
	CPI  R19,37
	BRNE _0x36
	LDI  R16,LOW(1)
	RJMP _0x37
_0x36:
	RCALL SUBOPT_0x15
_0x37:
	RJMP _0x34
_0x35:
	CPI  R30,LOW(0x1)
	BRNE _0x38
	CPI  R19,37
	BRNE _0x39
	RCALL SUBOPT_0x15
	LDI  R16,LOW(0)
	RJMP _0x34
_0x39:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x3A
	LDI  R17,LOW(1)
	RJMP _0x34
_0x3A:
	CPI  R19,43
	BRNE _0x3B
	LDI  R21,LOW(43)
	RJMP _0x34
_0x3B:
	CPI  R19,32
	BRNE _0x3C
	LDI  R21,LOW(32)
	RJMP _0x34
_0x3C:
	RJMP _0x3D
_0x38:
	CPI  R30,LOW(0x2)
	BRNE _0x3E
_0x3D:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x3F
	ORI  R17,LOW(128)
	RJMP _0x34
_0x3F:
	RJMP _0x40
_0x3E:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x34
_0x40:
	CPI  R19,48
	BRLO _0x43
	CPI  R19,58
	BRLO _0x44
_0x43:
	RJMP _0x42
_0x44:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x34
_0x42:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x48
	RCALL SUBOPT_0x16
	LD   R30,X
	ST   -Y,R30
	RCALL SUBOPT_0x17
	RJMP _0x49
_0x48:
	CPI  R30,LOW(0x73)
	BRNE _0x4B
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x18
	RCALL _strlen
	MOV  R16,R30
	RJMP _0x4C
_0x4B:
	CPI  R30,LOW(0x70)
	BRNE _0x4E
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x18
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x4C:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x4F
_0x4E:
	CPI  R30,LOW(0x64)
	BREQ _0x52
	CPI  R30,LOW(0x69)
	BRNE _0x53
_0x52:
	ORI  R17,LOW(4)
	RJMP _0x54
_0x53:
	CPI  R30,LOW(0x75)
	BRNE _0x55
_0x54:
	LDI  R30,LOW(_tbl10_G4*2)
	LDI  R31,HIGH(_tbl10_G4*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x56
_0x55:
	CPI  R30,LOW(0x58)
	BRNE _0x58
	ORI  R17,LOW(8)
	RJMP _0x59
_0x58:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x87
_0x59:
	LDI  R30,LOW(_tbl16_G4*2)
	LDI  R31,HIGH(_tbl16_G4*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x56:
	SBRS R17,2
	RJMP _0x5B
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x19
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x5C
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x5C:
	CPI  R21,0
	BREQ _0x5D
	SUBI R16,-LOW(1)
	RJMP _0x5E
_0x5D:
	ANDI R17,LOW(251)
_0x5E:
	RJMP _0x5F
_0x5B:
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x19
_0x5F:
_0x4F:
	SBRC R17,0
	RJMP _0x60
_0x61:
	CP   R16,R20
	BRSH _0x63
	SBRS R17,7
	RJMP _0x64
	SBRS R17,2
	RJMP _0x65
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x66
_0x65:
	LDI  R19,LOW(48)
_0x66:
	RJMP _0x67
_0x64:
	LDI  R19,LOW(32)
_0x67:
	RCALL SUBOPT_0x15
	SUBI R20,LOW(1)
	RJMP _0x61
_0x63:
_0x60:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x68
_0x69:
	CPI  R18,0
	BREQ _0x6B
	SBRS R17,3
	RJMP _0x6C
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x8A
_0x6C:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x8A:
	ST   -Y,R30
	RCALL SUBOPT_0x17
	CPI  R20,0
	BREQ _0x6E
	SUBI R20,LOW(1)
_0x6E:
	SUBI R18,LOW(1)
	RJMP _0x69
_0x6B:
	RJMP _0x6F
_0x68:
_0x71:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x73
	SBRS R17,3
	RJMP _0x74
	SUBI R19,-LOW(7)
	RJMP _0x75
_0x74:
	SUBI R19,-LOW(39)
_0x75:
_0x73:
	SBRC R17,4
	RJMP _0x77
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x79
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x78
_0x79:
	ORI  R17,LOW(16)
	RJMP _0x7B
_0x78:
	CP   R20,R18
	BRLO _0x7D
	SBRS R17,0
	RJMP _0x7E
_0x7D:
	RJMP _0x7C
_0x7E:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x7F
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x7B:
	SBRS R17,2
	RJMP _0x80
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x17
	CPI  R20,0
	BREQ _0x81
	SUBI R20,LOW(1)
_0x81:
_0x80:
_0x7F:
_0x77:
	RCALL SUBOPT_0x15
	CPI  R20,0
	BREQ _0x82
	SUBI R20,LOW(1)
_0x82:
_0x7C:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x72
	RJMP _0x71
_0x72:
_0x6F:
	SBRS R17,0
	RJMP _0x83
_0x84:
	CPI  R20,0
	BREQ _0x86
	SUBI R20,LOW(1)
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x17
	RJMP _0x84
_0x86:
_0x83:
_0x87:
_0x49:
	LDI  R16,LOW(0)
_0x34:
	RJMP _0x2F
_0x31:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,2
	RCALL __SAVELOCR2
	MOVW R26,R28
	RCALL __ADDW2R15
	__PUTW2R 16,17
	MOVW R26,R28
	ADIW R26,6
	RCALL SUBOPT_0x1A
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL SUBOPT_0x1A
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G4
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RCALL __LOADLOCR2
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	MOV  R4,R30
	ST   -Y,R4
	RJMP _USART_Transmit

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES
SUBOPT_0x1:
	LDI  R30,LOW(_tampon)
	LDI  R31,HIGH(_tampon)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x2:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x3:
	RCALL _lcd_gotoxy
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x4:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x5:
	RCALL _sprintf
	ADIW R28,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	LDI  R30,LOW(12)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CPI  R26,LOW(0x4)
	LDI  R30,HIGH(0x4)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x8:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x9:
	LD   R30,Z
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL __LSLW2
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xC:
	SUBI R30,LOW(-_Temps)
	SBCI R31,HIGH(-_Temps)
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xD:
	RCALL _lcd_puts
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xE:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL __LSLW2
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x10:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	RCALL __lcd_write_data
	RJMP __lcd_ready

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x12:
	RCALL __long_delay_G2
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x13:
	LDI  R30,LOW(32)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x14:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x15:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G4

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x16:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x17:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G4

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x18:
	RCALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x19:
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1A:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTWP1:
	ST   X+,R30
	ST   X,R31
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

