/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.2c Professional
Automatic Program Generator
 Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : 
Version : 
Date    : 12/11/2010
Author  : F4CG                            
Company : F4CG                            
Comments: 


Chip type           : ATmega8535
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*****************************************************/

#include <mega8535.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15 ;PORTC
#endasm
#include <lcd.h>
#include <delay.h>     // pour la fonction delay_ms();
#include <stdlib.h>

// Standard Input/Output functions
#include <stdio.h>

#define CTS     PIND.4
#define BUZZER  PINA.7

// Declare your global variables here

unsigned char trame, Statut, Information;
unsigned char Temps[20]; 
unsigned char tampon[20], Identifiant[10];

void USART_Transmit( unsigned char data )
{
	/* Wait for empty transmit buffer */
	while ( !( UCSRA & (0x20)) ); // Test de UDRE bit 5
	/* Put data into buffer, sends the data */
	UDR = data;
}

unsigned char USART_Receive( void )
{
	/* Wait for data to be received */
	while ( !(UCSRA & 0x80) ); // Test de RXC bit7

	/* Get and return received data from buffer */
	return UDR;
}

int VerifStatut (void)
{
	int Presence;
 	while(CTS==1);     //Attente que l'entre CTS soit active ( 0)
        trame='S';        //ou 0x53 : permet de vrifier le statut
        USART_Transmit(trame);
        Statut = USART_Receive();
    
    	if(Statut==0x96)      //Bit d'identification de la carte
        {
            Presence=1;
            sprintf(tampon,"Lecture  ");
            lcd_gotoxy(0,0);
            lcd_puts(tampon);
        }
        else
        {
            Presence=0;
            sprintf(tampon,"Pas Carte");
            lcd_gotoxy(0,0);
            lcd_puts(tampon);
        }
    return Presence;   
}

void Recoit_UID (void)
{
    int i, z;
	
    unsigned char car;
    i=0;
    for(z=0;z<7;z++)
    {
    	Identifiant[z] = 0;
    }
    while(CTS==1);
    trame='U',     //ou 0x55 : permet de lire l'UID
    USART_Transmit(trame);
    Statut = USART_Receive();
    
    if(Statut == 150)
    {
    	while(i<=6)     // 6 pour les MIFARE 1k/4k card types
    	{
        	car = USART_Receive();
        	Identifiant[i]=car;
        	i++;
    	}
    }

}

void Recoit_Info (int Borne)
{
    int i;
	
    unsigned char car;
    i=0;
    while(CTS==1);
    
    trame='R';     //permet de lire la trame
    USART_Transmit(trame);	//Transmission de 'R' ou 0x52
    USART_Transmit(Borne*18);  	//Transmission de l'adresse de location    
    USART_Transmit(0x00);     	//Transmission du code de lecture
    Information = USART_Receive();
    
    Information = (Information & 0xCF);	//Mise en place d'un masque pour lecture ncessaire du Acknowledge 
    
    
    if(Information == 0x86)
    {
    	//Temps[1] = USART_Receive();
		
    	while(i<=15)		//16 bits  rcuprer
    	{
    		car = USART_Receive(); 
    		Temps[i] = car;
    		i++;
    	}
    }

    	//lcd_clear();
}  
    
void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 9600
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x67;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x80;
SFIOR=0x00;

// LCD module initialization
lcd_init(16);
 
while (1)
{
        unsigned char NumeroBorneHexa;
	int z, PresenceCarte;
	PresenceCarte = VerifStatut ();   // Appelle de la fonction permettant de vrifier le statut
        
    	NumeroBorneHexa = (PINA&0x0f);
    
    		sprintf(tampon, "%x", NumeroBorneHexa);
  		lcd_gotoxy(12, 0);
  		lcd_puts(tampon);
    	if(PresenceCarte==1)
    	{
    		// Possiblit de lire l'identifiant unique de la carte

		//Recoit_UID();
		
		for(z=0;z<4;z++)
        	{
        		sprintf(tampon,"%3d",Identifiant[z]);
    			lcd_gotoxy(z*4,1);   
    			lcd_puts(tampon);
        	}
        	Recoit_Info(NumeroBorneHexa);
  		/*sprintf(tampon, "0x%x", Information);	//Affichage du Acknowledge de reception des 16 bits (avec masque)
  		lcd_gotoxy(0,3);
  		lcd_puts(tampon);*/
  		
  		for(z=0;z<4;z++)            	//Lecture complte des 16 bits affich sur 4 lignes
  		{
  			sprintf(tampon, "%3d", Temps[z]);	//4 premiers bits = UID
  			lcd_gotoxy(z*4, 1);
  			lcd_puts(tampon);
  			
  			sprintf(tampon, "%3d", Temps[z+4]);	//bits qui nous intresse
  			lcd_gotoxy((z)*4, 2);
  			lcd_puts(tampon);
  			
  			sprintf(tampon, "%3d", Temps[z+8]);
  			lcd_gotoxy((z)*4, 3);
  			lcd_puts(tampon);
  			/*
  			sprintf(tampon, "%3d", Temps[z+12]);
  			lcd_gotoxy((z)*4, 3);
  			lcd_puts(tampon);*/
  		}
  	
   
	}  	
        
}
}

